<template lang="pug">

mixin Badge(number)
  div.badge.badge-pill.mr-1.pl-2.pr-2.d-lg-inline&attributes(attributes)= number

mixin Message(prefix, code, message)
  .row.m-1.justify-content-left.align-items-start
    .col-auto.p-1.text-nowrap
      strong= `[${prefix}${code}]`
    .col-auto.p-1.text-justify
      span= message

.alert(:class="alertClass" role='alert')
  .row.m-1.justify-content-between.align-items-center(@click="toggleDetails()" :class="{ clickable: showError }")
    .col.m-0.p-0(v-if="showError")
      i(v-if="showDetails").fa.fa-caret-down
      i(v-else).fa.fa-caret-right
    .col.m-0.p-0
      h6.m-0(align='center')  {{ strState || placeholder }}
    .col.m-0.p-0(v-if="showError")
      div.float-right
        +Badge(`{{warnings.length}}`)(v-if="!$butils.isEmpty(warnings)").badge-warning
        +Badge(`{{errors.length}}`)(v-if="!$butils.isEmpty(errors)").badge-danger
  AnimBlock(anim='height')
    div(v-show="showDetails")
      hr
      .row
        .col-12.text-wrap(v-for="e in errors")
          +Message('E', `{{e.code}}`, `{{e.message}}`)
        .col-12.text-wrap(v-for="w in warnings")
          +Message('W', `{{w.code}}`, `{{w.message}}`)
</template>
<script>
export { default } from "./BaseDimStateAlert.vue.js";
</script>
